local mod = RW:Boss("Lady Deathwhisper", "Icecrown Citadell", "Icecrown Citadell", "The Entryway")
local L

-- 3.3?
if not QueryQuestsCompleted then return end

---------------------
-- Variables

local tDominateDur, tDominateCD
local tDNDCD, tDNDDur
local tBerserk

local wDND

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Lady Deathwhisper"
		
		L.mana_barrier = GetSpellInfo(70842)
	end
	L = mod:GetLocale()
	mod.L = L
	
	mod:SetTrigger(36855)
	mod:SetWin()
	
	self:AddCategory(L.name, "Adds")
	self:AddSpellOption(L.name, 70842, 71289)
	
	self:AddBoolOption("ManaShieldHelath", "Show Mana Barrier health", L.name, true)
	
	tDominateDur	= self:DurTargetTimer(20, 71289)
	tDominateCD		= self:CDTimer(40, 71289)
	tDNDCD			= self:CDTimer(20, 72109)
	tDNDDur			= self:DurTimer(10, 72109)
	tBerserk		= self:BerserkTimer(600)
	
	wDND			= self:RunawayWarning(72109)
end

----------------------
-- Locals

local manaLeft

local function ManaBarrierUpdate()
	local uID = mod:UIDFromCID(36855)
	if uID then
		manaLeft = UnitMana(uID) / UnitManaMax(uID)
	end
	return manaLeft
end

----------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Dominate", 71289)
	self:Track("DND", 72109, 72108)
	
	tBerserk:Start()
	
	if self.db.profile.ManaShieldHelath then
		self:SendMessage("RW_AddHealthFrame", ManaBarrierUpdate, L.mana_barrier)
	end
	
	manaLeft = 1
end

function mod:Dominate(event, args)
	if event == "SPELL_AURA_APPLIED" then
		tDominateDur:Start(args.dName)
		tDominateCD:Start()
	end
end

function mod:DND(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tDNDCD:Start()
		tDNDDur:Start()
		
	elseif event == "SPELL_AURA_APPLIED" then
		wDND:Show()
	end
end